-- DirtyRecruit
-- Author: Dirtygurl
-- License: GNU GPL v3, 29 June 2007 (see LICENSE.txt)

local DirtyRecruit = {};
DirtyRecruit.Version = GetAddOnMetadata("DirtyRecruit", "Version");

DirtyRecruit.LibQTip = LibStub("LibQTip-1.0");

DirtyRecruit.PerPlayer =
{
	Active = nil,
	InCombat = nil,
	Spam = "guild",
	UpdateInterval = 300.0, -- 5 minutes
	Ad = nil,
	TestMode = nil,
	Zone = nil
};

DirtyRecruit.TimeSinceLastUpdate = 0;
DirtyRecruit.TimeSinceLastCheck = 0;

function DirtyRecruit.Print(msg)
	if DEFAULT_CHAT_FRAME then
		DEFAULT_CHAT_FRAME:AddMessage("|cFF00FF00[DirtyRecruit]|r "..msg, 1, 1, 1)
	end
end

function DirtyRecruit.IsInPVPOrInstance()
	local instance = IsInInstance()
	local zone = GetZoneText()
	if instance ~= nil or zone == DIRTYRECRUIT_ZONE_WINTERGRASP then
		return 1
	end
	return nil
end

function DirtyRecruit.AdvertiseTest()
	local gName = GetGuildInfo("player")
	if gName then
		local iIndex = nil
		local genIndex, nGeneral = GetChannelName(DIRTYRECRUIT_CHANNEL_GENERAL.." - "..GetZoneText())
		local trdIndex, nTrade = GetChannelName(DIRTYRECRUIT_CHANNEL_TRADE.." - City")
		local grIndex, nGuildRecruitment = GetChannelName(DIRTYRECRUIT_CHANNEL_GUILDRECRUITMENT.." - City")
		local lfgIndex, nLookingForGroup = GetChannelName(DIRTYRECRUIT_CHANNEL_LOOKINGFORGROUP)
		local ldeIndex, nLocalDefense = GetChannelName(DIRTYRECRUIT_CHANNEL_LOCALDEFENSE.." - "..GetZoneText())
		if nLocalDefense and (DirtyRecruit.PerPlayer.Spam == "all" or DirtyRecruit.PerPlayer.Spam == "lde") then
			iIndex = ldeIndex
			iValue = nLocalDefense
		elseif nLookingForGroup and (DirtyRecruit.PerPlayer.Spam == "all" or DirtyRecruit.PerPlayer.Spam == "lfg") then
			iIndex = lfgIndex
			iValue = nLookingForGroup
		elseif nGuildRecruitment and (DirtyRecruit.PerPlayer.Spam == "all" or DirtyRecruit.PerPlayer.Spam == "guild") then
			iIndex = grIndex
			iValue = nGuildRecruitment
		elseif DirtyRecruit.PerPlayer.Zone == "City" and nTrade and (DirtyRecruit.PerPlayer.Spam == "all" or DirtyRecruit.PerPlayer.Spam == "trade") then
			iIndex = trdIndex
			iValue = nTrade
		elseif DirtyRecruit.PerPlayer.Zone == "City" and nGeneral and (DirtyRecruit.PerPlayer.Spam == "all" or DirtyRecruit.PerPlayer.Spam == "general") then
			iIndex = genIndex
			iValue = nGeneral
		elseif nTrade and nGeneral and (DirtyRecruit.PerPlayer.Spam == "all" or DirtyRecruit.PerPlayer.Spam == "major") then
			iIndex = trdIndex
			iValue = nTrade
		end
		if iIndex ~= nil and DirtyRecruit.PerPlayer.Zone ~= nil then
			if DirtyRecruit.TestMode ~= nil then
				DirtyRecruit.Print("["..iIndex..". "..iValue.."]: "..DirtyRecruit.PerPlayer.Ad)
			else
				ChatThrottleLib:SendChatMessage("NORMAL", "DirtyRecruit", DirtyRecruit.PerPlayer.Ad, "CHANNEL", nil, iIndex)
				ChatThrottleLib:SendAddonMessage("NORMAL", "DirtyRecruit", "guildAdvertised|"..DirtyRecruit.PerPlayer.Zone.."|"..UnitName("player"), "GUILD")
			end
		end
	end
end

function DirtyRecruit.Advertise()
	local gName = GetGuildInfo("player")
	if gName then
		local iIndex = nil
		local genIndex, nGeneral = GetChannelName(DIRTYRECRUIT_CHANNEL_GENERAL.." - "..GetZoneText())
		local trdIndex, nTrade = GetChannelName(DIRTYRECRUIT_CHANNEL_TRADE.." - City")
		local grIndex, nGuildRecruitment = GetChannelName(DIRTYRECRUIT_CHANNEL_GUILDRECRUITMENT.." - City")
		local lfgIndex, nLookingForGroup = GetChannelName(DIRTYRECRUIT_CHANNEL_LOOKINGFORGROUP)
		local ldeIndex, nLocalDefense = GetChannelName(DIRTYRECRUIT_CHANNEL_LOCALDEFENSE.." - "..GetZoneText())
		if nLocalDefense and (DirtyRecruit.PerPlayer.Spam == "all" or DirtyRecruit.PerPlayer.Spam == "lde") then
			iIndex = ldeIndex
			iValue = nLocalDefense
		elseif nLookingForGroup and (DirtyRecruit.PerPlayer.Spam == "all" or DirtyRecruit.PerPlayer.Spam == "lfg") then
			iIndex = lfgIndex
			iValue = nLookingForGroup
		elseif nGuildRecruitment and (DirtyRecruit.PerPlayer.Spam == "all" or DirtyRecruit.PerPlayer.Spam == "guild") then
			iIndex = grIndex
			iValue = nGuildRecruitment
		elseif DirtyRecruit.PerPlayer.Zone == "City" and nTrade and (DirtyRecruit.PerPlayer.Spam == "all" or DirtyRecruit.PerPlayer.Spam == "trade") then
			iIndex = trdIndex
			iValue = nTrade
		elseif DirtyRecruit.PerPlayer.Zone == "City" and nGeneral and (DirtyRecruit.PerPlayer.Spam == "all" or DirtyRecruit.PerPlayer.Spam == "general") then
			iIndex = genIndex
			iValue = nGeneral
		elseif nTrade and nGeneral and (DirtyRecruit.PerPlayer.Spam == "all" or DirtyRecruit.PerPlayer.Spam == "major") then
			iIndex = trdIndex
			iValue = nTrade
		end
		if iIndex ~= nil and DirtyRecruit.PerPlayer.Zone ~= nil then
			if DirtyRecruit.PerPlayer.TestMode ~= nil then
				DirtyRecruit.Print("["..iIndex..". "..iValue.."]: "..DirtyRecruit.PerPlayer.Ad)
			else
				ChatThrottleLib:SendChatMessage("NORMAL", "DirtyRecruit", DirtyRecruit.PerPlayer.Ad, "CHANNEL", nil, iIndex)
				ChatThrottleLib:SendAddonMessage("NORMAL", "DirtyRecruit", "guildAdvertised|"..DirtyRecruit.PerPlayer.Zone.."|"..UnitName("player"), "GUILD")
			end
		end
	end
end

function DirtyRecruit.LoadPanel()
	DirtyRecruit.Panel = CreateFrame("Frame", "DirtyRecruitPanel", UIParent)
	DirtyRecruit.Panel.name = "DirtyRecruit"
	DirtyRecruit.Panel.okay = function(self) DirtyRecruit.Panel_Okay() end
	DirtyRecruit.Panel.default = function(self) DirtyRecruit.Panel_Default() end
	
	DirtyRecruit.Font_Title = DirtyRecruit.Panel:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge")
	DirtyRecruit.Font_Title:SetPoint("TOPLEFT", DirtyRecruit.Panel, "TOPLEFT", 15, -15)
	DirtyRecruit.Font_Title:SetText("DirtyRecruit v"..DirtyRecruit.Version)
	-- 
	DirtyRecruit.Font_Desc = DirtyRecruit.Panel:CreateFontString(nil, "OVERLAY", "GameFontHighlightSmall")
	DirtyRecruit.Font_Desc:SetPoint("TOPLEFT", DirtyRecruit.Font_Title, "BOTTOMLEFT", 0, -10)
	DirtyRecruit.Font_Desc:SetText("I did it all for the nookie.")
	-- Active
	DirtyRecruit.Font_Active = DirtyRecruit.Panel:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	DirtyRecruit.Font_Active:SetPoint("TOPLEFT", DirtyRecruit.Font_Desc, "TOPLEFT", 0, -25)
	DirtyRecruit.Font_Active:SetText("Enable:")
	DirtyRecruit.CheckBox_Active = CreateFrame("CheckButton", "DirtyRecruitCheckBox_Active", DirtyRecruit.Panel, "InterfaceOptionsCheckButtonTemplate")
	DirtyRecruit.CheckBox_Active:SetPoint("TOPLEFT", DirtyRecruit.Font_Active, "TOPRIGHT", 10, 5)
	-- Spam
	DirtyRecruit.Font_Spam = DirtyRecruit.Panel:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	DirtyRecruit.Font_Spam:SetPoint("TOPLEFT", DirtyRecruit.Font_Active, "TOPLEFT", 0, -25)
	DirtyRecruit.Font_Spam:SetText("Spam:")
	DirtyRecruit.Menu_Spam = CreateFrame("Frame", "DirtyRecruitMenu_Spam", DirtyRecruit.Panel, "UIDropDownMenuTemplate")
	DirtyRecruit.Menu_Spam:SetPoint("TOPLEFT", DirtyRecruit.Font_Spam, "TOPRIGHT", 10, 5)
	DirtyRecruit.Menu_Spam.displayMode = "MENU"
	DirtyRecruit.Menu_Spam.initialize = DirtyRecruit.Panel_Menu_Spam
	DirtyRecruit.Menu_Spam.info = {}
	UIDropDownMenu_SetWidth(DirtyRecruit.Menu_Spam, 125)
	-- UpdateInterval
	DirtyRecruit.Font_UpdateInterval = DirtyRecruit.Panel:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	DirtyRecruit.Font_UpdateInterval:SetPoint("TOPLEFT", DirtyRecruit.Font_Spam, "TOPLEFT", 0, -30)
	DirtyRecruit.Font_UpdateInterval:SetText("Spam Interval:")
	DirtyRecruit.EditBox_UpdateInterval = CreateFrame("EditBox", "DirtyRecruitEditBox_UpdateInterval", DirtyRecruit.Panel)
	DirtyRecruit.EditBox_UpdateInterval:SetPoint("TOPLEFT", DirtyRecruit.Font_UpdateInterval, "TOPRIGHT", 10, 5)
	DirtyRecruit.EditBox_UpdateInterval:SetWidth(60)
	DirtyRecruit.EditBox_UpdateInterval:SetHeight(20)
	DirtyRecruit.EditBox_UpdateInterval:SetAutoFocus(false)
	DirtyRecruit.EditBox_UpdateInterval:SetFontObject(GameFontHighlightSmall)
	DirtyRecruit.EditBox_UpdateInterval:SetTextInsets(8, 8, 8, 8)
	DirtyRecruit.EditBox_UpdateInterval:SetBackdrop
	{
		bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
		edgeSize = 16,
		insets =
		{
			left = 4,
			right = 4,
			top = 4,
			bottom = 4
		},
	}
	DirtyRecruit.EditBox_UpdateInterval:SetBackdropColor(.1, .1, .1, 1)
	DirtyRecruit.EditBox_UpdateInterval:SetNumeric(true)
	-- Ad
	DirtyRecruit.Font_Ad = DirtyRecruit.Panel:CreateFontString(nil, "OVERLAY", "GameFontNormal")
	DirtyRecruit.Font_Ad:SetPoint("TOPLEFT", DirtyRecruit.Font_UpdateInterval, "TOPLEFT", 0, -30)
	DirtyRecruit.Font_Ad:SetText("Ad:")
	DirtyRecruit.EditBox_Ad = CreateFrame("EditBox", "DirtyRecruitEditBox_Ad", DirtyRecruit.Panel)
	DirtyRecruit.EditBox_Ad:SetPoint("TOPLEFT", DirtyRecruit.Font_Ad, "TOPRIGHT", 10, 5)
	DirtyRecruit.EditBox_Ad:SetWidth(300)
	DirtyRecruit.EditBox_Ad:SetHeight(160)
	DirtyRecruit.EditBox_Ad:SetMaxLetters(255)
	DirtyRecruit.EditBox_Ad:SetMultiLine(true)
	DirtyRecruit.EditBox_Ad:SetAutoFocus(false)
	DirtyRecruit.EditBox_Ad:SetFontObject(GameFontHighlightSmall)
	DirtyRecruit.EditBox_Ad:SetTextInsets(8, 8, 8, 8)
	DirtyRecruit.EditBox_Ad:SetBackdrop
	{
		bgFile = "Interface\\ChatFrame\\ChatFrameBackground",
		edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
		edgeSize = 16,
		insets =
		{
			left = 4,
			right = 4,
			top = 4,
			bottom = 4
		},
	}
	DirtyRecruit.EditBox_Ad:SetBackdropColor(.1, .1, .1, 1)
	-- 
	DirtyRecruit.Panel:SetScript("OnShow", DirtyRecruit.Panel_OnShow)
	DirtyRecruit.Panel.show = false
	InterfaceOptions_AddCategory(DirtyRecruit.Panel)
end

function DirtyRecruit.Panel_OnShow()
	-- Active
	DirtyRecruit.CheckBox_Active:SetChecked(DirtyRecruit.PerPlayer.Active)
	-- Spam
	UIDropDownMenu_Initialize(DirtyRecruit.Menu_Spam, DirtyRecruit.Panel_Menu_Spam)
	UIDropDownMenu_SetSelectedValue(DirtyRecruit.Menu_Spam, DirtyRecruit.PerPlayer.Spam)
	-- UpdateInterval
	DirtyRecruit.EditBox_UpdateInterval:SetNumber(DirtyRecruit.PerPlayer.UpdateInterval)
	-- Ad
	if (DirtyRecruit.PerPlayer.Ad == nil) then
		DirtyRecruit.PerPlayer.Ad = DIRTYRECRUIT_PERPLAYER_AD;
	end
	DirtyRecruit.EditBox_Ad:SetText(DirtyRecruit.PerPlayer.Ad);
	-- 
	DirtyRecruit.Panel.shown = true
end

function DirtyRecruit.Panel_Menu_Spam(self, level)
	level = level or 1
	if not level then return end
	local info = self.info
	
	info.text = "All Channels"
	info.value = "all"
	info.owner = this:GetParent()
	info.checked = nil
	info.icon = nil
	info.func = DirtyRecruit.Panel_ClickMenu
	UIDropDownMenu_AddButton(info, level)
	
	info.text = "Guild Recruitment"
	info.value = "guild"
	info.owner = this:GetParent()
	info.checked = nil
	info.icon = nil
	info.func = DirtyRecruit.Panel_ClickMenu
	UIDropDownMenu_AddButton(info, level)
	
	info.text = "Trade Channel"
	info.value = "trade"
	info.owner = this:GetParent()
	info.checked = nil
	info.icon = nil
	info.func = DirtyRecruit.Panel_ClickMenu
	UIDropDownMenu_AddButton(info, level)
	
	info.text = "Major City: General"
	info.value = "major"
	info.owner = this:GetParent()
	info.checked = nil
	info.icon = nil
	info.func = DirtyRecruit.Panel_ClickMenu
	UIDropDownMenu_AddButton(info, level)
	
	info.text = "General"
	info.value = "general"
	info.owner = this:GetParent()
	info.checked = nil
	info.icon = nil
	info.func = DirtyRecruit.Panel_ClickMenu
	UIDropDownMenu_AddButton(info, level)
	
	info.text = "Looking For Group"
	info.value = "lfg"
	info.owner = this:GetParent()
	info.checked = nil
	info.icon = nil
	info.func = DirtyRecruit.Panel_ClickMenu
	UIDropDownMenu_AddButton(info, level)
	
	info.text = "Local Defense"
	info.value = "lde"
	info.owner = this:GetParent()
	info.checked = nil
	info.icon = nil
	info.func = DirtyRecruit.Panel_ClickMenu
	UIDropDownMenu_AddButton(info, level)
end

function DirtyRecruit.Panel_ClickMenu()
	UIDropDownMenu_SetSelectedValue(this.owner, this.value);
end

function DirtyRecruit.Panel_Okay()
	if DirtyRecruit.Panel.shown then
		-- Active
		if DirtyRecruit.CheckBox_Active:GetChecked() then
			DirtyRecruit.PerPlayer.Active = true
		else
			DirtyRecruit.PerPlayer.Active = nil
		end
		-- Spam
		DirtyRecruit.PerPlayer.Spam = UIDropDownMenu_GetSelectedValue(DirtyRecruit.Menu_Spam)
		local grIndex = GetChannelName(DIRTYRECRUIT_CHANNEL_GUILDRECRUITMENT.." - City")
		local ldeIndex = GetChannelName(DIRTYRECRUIT_CHANNEL_LOCALDEFENSE.." - "..GetZoneText())
		if DirtyRecruit.PerPlayer.Zone == "City" and DirtyRecruit.PerPlayer.Spam == "all" or DirtyRecruit.PerPlayer.Spam == "guild" or DirtyRecruit.PerPlayer.Spam == "lde" then
			if grIndex == 0 and DirtyRecruit.PerPlayer.Spam == "guild" then
				JoinChannelByName(DIRTYRECRUIT_CHANNEL_GUILDRECRUITMENT)
			elseif ldeIndex == 0 and DirtyRecruit.PerPlayer.Spam == "lde" then
				JoinChannelByName(DIRTYRECRUIT_CHANNEL_LOCALDEFENSE)
			end
		elseif grIndex > 0 and DirtyRecruit.PerPlayer.Spam == "guild" then
			LeaveChannelByName(DIRTYRECRUIT_CHANNEL_GUILDRECRUITMENT)
		elseif ldeIndex > 0 and DirtyRecruit.PerPlayer.Spam == "lde" then
			LeaveChannelByName(DIRTYRECRUIT_CHANNEL_LOCALDEFENSE)
		end
		-- UpdateInterval
		local UpdateInterval = DirtyRecruit.EditBox_UpdateInterval:GetNumber()
		if UpdateInterval >= 60 then
			DirtyRecruit.PerPlayer.UpdateInterval = DirtyRecruit.EditBox_UpdateInterval:GetNumber()
		end
		-- Ad
		DirtyRecruit.PerPlayer.Ad = DirtyRecruit.EditBox_Ad:GetText()
		DirtyRecruit.UpdateSettings()
	end
end

function DirtyRecruit.Panel_Default()
	DirtyRecruit.PerPlayer =
	{
		Active = nil,
		InCombat = nil,
		Spam = "guild",
		UpdateInterval = 300.0, -- 5 minutes
		Ad = nil,
		TestMode = nil,
		Zone = nil
	}
	DirtyRecruit.Panel_OnShow()
end

function DirtyRecruit.OnUpdateSpam(self, elapsed)
	--DirtyRecruit.Print("OnUpdate")
	local CityInterval = tonumber(30)
	DirtyRecruit.TimeSinceLastCheck = DirtyRecruit.TimeSinceLastCheck + elapsed
	if DirtyRecruit.TimeSinceLastCheck and DirtyRecruit.TimeSinceLastCheck >= CityInterval then
		DirtyRecruit.ZoneChangedNewArea()
		DirtyRecruit.TimeSinceLastCheck = 0
	end
	local UpdateInterval = tonumber(DirtyRecruit.PerPlayer.UpdateInterval)
	DirtyRecruit.TimeSinceLastUpdate = DirtyRecruit.TimeSinceLastUpdate + elapsed
	if DirtyRecruit.TimeSinceLastUpdate and DirtyRecruit.TimeSinceLastUpdate >= UpdateInterval then
		if IsInGuild() and CanGuildInvite() and DirtyRecruit.PerPlayer.Ad ~= nil and DirtyRecruit.PerPlayer.Active and not DirtyRecruit.PerPlayer.InCombat and not DirtyRecruit.IsInPVPOrInstance() then
			DirtyRecruit.Advertise()
		end
		DirtyRecruit.TimeSinceLastUpdate = 0
	end
end

function DirtyRecruit.OnPlayerRegenDisabled()
	--DirtyRecruit.Print("OnEvent:PLAYER_REGEN_DISABLED")
	DirtyRecruit.PerPlayer.InCombat = 1
end

function DirtyRecruit.OnPlayerRegenEnabled()
	--DirtyRecruit.Print("OnEvent:PLAYER_REGEN_ENABLED")
	DirtyRecruit.PerPlayer.InCombat = nil
end

function DirtyRecruit.ZoneChangedNewArea()
	--DirtyRecruit.Print("OnEvent:ZONE_CHANGED_NEW_AREA")
	DirtyRecruit.PerPlayer.Zone = nil
	local currchans =  {GetChannelList()}
	for i=2,#currchans,2 do
		if currchans[i] ~= nil and currchans[i] == "Trade" and (DirtyRecruit.PerPlayer.Spam == "trade" or DirtyRecruit.PerPlayer.Spam == "major") then
			-- If we have a trade chan we are in a city
			DirtyRecruit.PerPlayer.Zone = "City"
		end
	end
	if DirtyRecruit.PerPlayer.Zone ~= "City" then
		DirtyRecruit.PerPlayer.Zone = GetZoneText()
	end
	--DirtyRecruit.Print("Zone Changed: "..DirtyRecruit.PerPlayer.Zone)
end

function DirtyRecruit.OnChatMsgAddOn(action)
	--DirtyRecruit.Print("OnEvent:CHAT_MSG_ADDON")
	local a, b, c = strsplit("|", action)
	if a == "guildAdvertised" and b == GetZoneText() and c ~= UnitName("player") then
		DirtyRecruit.Print("Guild Advertised, Reset on timer has been issued")
		DirtyRecruit.TimeSinceLastUpdate = 0
	end
	if a == "guildSync" and b then
		DirtyRecruit.Print("Sync request from "..b)
		ChatThrottleLib:SendAddonMessage("NORMAL", "DirtyRecruit", "guildSynced|"..DirtyRecruit.PerPlayer.Ad, "WHISPER", b)
	end
	if a == "guildSynced" and b then
		DirtyRecruit.PerPlayer.Ad = b
		DirtyRecruit.UpdateSettings()
		DirtyRecruit.Panel_OnShow()
	end
end

function DirtyRecruit.OnVariablesLoaded()
	--DirtyRecruit.Print("OnEvent:VARIABLES_LOADED")
	--[[
	-- Global Variables
	--]]
	if not DirtyRecruitGlobal then
		DirtyRecruitGlobal = DirtyRecruit.Global
	end
	if not DirtyRecruitPerPlayer then
		DirtyRecruitPerPlayer = DirtyRecruit.PerPlayer
	end
	--[[
	-- Updated Variables
	--]]
	if not DirtyRecruitPerPlayer.Spam then
		DirtyRecruitPerPlayer.Spam = DirtyRecruit.PerPlayer.Spam
	end
	DirtyRecruit.Global = DirtyRecruitGlobal
	DirtyRecruit.PerPlayer = DirtyRecruitPerPlayer
end

function DirtyRecruit.OnAddOnLoaded()
	--DirtyRecruit.Print("OnEvent:ADDON_LOADED")
	DirtyRecruit.LoadPanel()
	SlashCmdList["DIRTYRECRUIT"] = DirtyRecruit.SlashHandler
	SLASH_DIRTYRECRUIT1 = "/dirtyrecruit"
	DirtyRecruit.Print("DirtyRecruit Loaded. Type /dirtyrecruit for more information.")
end

function DirtyRecruit.OnEvent()
	if event == "PLAYER_REGEN_DISABLED" then
		DirtyRecruit.OnPlayerRegenDisabled()
	elseif event == "PLAYER_REGEN_ENABLED" then
		DirtyRecruit.OnPlayerRegenEnabled()
	elseif event == "ZONE_CHANGED_NEW_AREA" then
		DirtyRecruit.ZoneChangedNewArea()
	elseif event == "CHAT_MSG_ADDON" and arg1 == "DirtyRecruit" then
		DirtyRecruit.OnChatMsgAddOn(arg2)
	elseif event == "VARIABLES_LOADED" then
		DirtyRecruit.OnVariablesLoaded()
	elseif event == "ADDON_LOADED" and arg1 == "DirtyRecruit" then
		DirtyRecruit.OnAddOnLoaded()
	end
end

function DirtyRecruit.UpdateSettings()
	DirtyRecruitGlobal = DirtyRecruit.Global
	DirtyRecruitPerPlayer = DirtyRecruit.PerPlayer
end

function DirtyRecruit.SlashHandler(cmd)
	local cmdTmp, arg = cmd:match("^(%S*)%s*(.-)$")
	if arg then
		cmd = strlower(cmdTmp)
	else
		cmd = strlower(cmd)
	end
	if cmd == "version" or cmd == "v" then
		DirtyRecruit.Print("Name: DirtyRecruit, Version: "..DirtyRecruit.Version)
	elseif cmd == "help" then
		DirtyRecruit.Print("Open interface addon options to configure settings.")
	elseif cmd == "config" then
		DirtyRecruit.Panel_OnShow()
	elseif cmd == "reset" then
		DirtyRecruit.Panel_Default()
	elseif cmd == "sync" then
		DirtyRecruit.Print("Requested sync from "..arg)
		ChatThrottleLib:SendAddonMessage("NORMAL", "DirtyRecruit", "guildSync|DR|"..UnitName("player"), "WHISPER", arg)
	elseif cmd == "testmode" then
		if DirtyRecruit.PerPlayer.TestMode ~= nil then
			DirtyRecruit.TestMode = nil
			DirtyRecruit.Print("Test mode off")
		else
			DirtyRecruit.TestMode = 1
			DirtyRecruit.Print("Test mode on")
		end
	elseif cmd == "test" then
		if DirtyRecruit.PerPlayer.Ad then
			DirtyRecruit.AdvertiseTest()
		else
			DirtyRecruit.Print("no advertisement was found")
		end
	elseif cmd == "on" then
		DirtyRecruit.PerPlayer.Active = true
		DirtyRecruit.UpdateSettings()
	elseif cmd == "off" then
		DirtyRecruit.PerPlayer.Active = nil
		DirtyRecruit.UpdateSettings()
	else
		DirtyRecruit.Print("DirtyRecruit v"..DirtyRecruit.Version)
		DirtyRecruit.Print("Syntax: |cffffff7f/dirtyrecruit <command> <args>|r")
		DirtyRecruit.Print("  |cff00ff00v|version|r - Shows addon version.")
		DirtyRecruit.Print("  |cff00ff00on|off|r - Enable/disable advertising.")
		DirtyRecruit.Print("  |cff00ff00config|r - Shows the configuration panel.")
		DirtyRecruit.Print("  |cff00ff00reset|r - Resets all data to original.")
		DirtyRecruit.Print("  |cff00ff00sync <character>|r - Syncs data from a character.")
		DirtyRecruit.Print("  |cff00ff00test|r - Prints out a test advertisement for private viewing.")
		DirtyRecruit.Print("  |cff00ff00help|r - Shows addon help.")
	end
end

DirtyRecruit.FrameSpam = CreateFrame("Frame")
DirtyRecruit.FrameSpam:SetScript("OnUpdate", DirtyRecruit.OnUpdateSpam)

DirtyRecruit.Frame = DirtyRecruit.LibQTip:Acquire("DirtyRecruitFrame")
DirtyRecruit.Frame:RegisterEvent("PLAYER_REGEN_DISABLED")
DirtyRecruit.Frame:RegisterEvent("PLAYER_REGEN_ENABLED")
DirtyRecruit.Frame:RegisterEvent("ZONE_CHANGED_NEW_AREA")
DirtyRecruit.Frame:RegisterEvent("CHAT_MSG_ADDON")
DirtyRecruit.Frame:RegisterEvent("VARIABLES_LOADED")
DirtyRecruit.Frame:RegisterEvent("ADDON_LOADED")
DirtyRecruit.Frame:SetScript("OnEvent", DirtyRecruit.OnEvent)